////////////////////////////////////////////////////////////////////////////////
// Engineer:       Michael Siegenthaler
//
// Design Name:    Hex to 7-Segment Decoder
// Module Name:    hex7seg
// Revision:       July 2, 2005
// 
////////////////////////////////////////////////////////////////////////////////

function [0:6] hex7seg;
  input [3:0] hex;
  begin
    case (hex)
      4'b0000: hex7seg = 7'b0000001; // 0
      4'b0001: hex7seg = 7'b1001111; // 1
      4'b0010: hex7seg = 7'b0010010; // 2
      4'b0011: hex7seg = 7'b0000110; // 3
      4'b0100: hex7seg = 7'b1001100; // 4
      4'b0101: hex7seg = 7'b0100100; // 5
      4'b0110: hex7seg = 7'b0100000; // 6
      4'b0111: hex7seg = 7'b0001111; // 7
      4'b1000: hex7seg = 7'b0000000; // 8
      4'b1001: hex7seg = 7'b0001100; // 9
      4'b1010: hex7seg = 7'b0001000; // A
      4'b1011: hex7seg = 7'b1100000; // b
      4'b1100: hex7seg = 7'b0110001; // C
      4'b1101: hex7seg = 7'b1000010; // d
      4'b1110: hex7seg = 7'b0110000; // E
      default: hex7seg = 7'b0111000; // F
    endcase
  end
endfunction
