`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Engineer:       Michael Siegenthaler
//
// Design Name:    Pegasus Seven Segment Display Driver
// Module Name:    segdrive
// Revision:       July 2, 2005
// 
////////////////////////////////////////////////////////////////////////////////
module segdrive(mclk, segs3, segs2, segs1, segs0, cathodes, anodes);

  // inputs/outputs
  input mclk;
  input [0:7] segs3;
  input [0:7] segs2;
  input [0:7] segs1;
  input [0:7] segs0;
  output [0:7] cathodes;
  output [3:0] anodes;

  // external nodes
  wire mclk;
  wire [0:7] segs3, segs2, segs1, segs0;
  reg [0:7] cathodes;
  reg [3:0] anodes;

  // internal nodes
  wire clk;
  reg [15:0] clkcount;

  // clock divider
  always @(posedge mclk) begin
    clkcount <= clkcount+1'b1;
  end
  assign clk = clkcount[15];

  // drive anodes and cathodes
  always @(posedge clk) begin
    if (anodes==4'b0111) begin
      anodes <= 4'b1110;
      cathodes <= segs0;
    end
    else if (anodes==4'b1110) begin
      anodes <= 4'b1101;
      cathodes <= segs1;
    end
    else if (anodes==4'b1101) begin
      anodes <= 4'b1011;
      cathodes <= segs2;
    end
    else if (anodes==4'b1011) begin
      anodes <= 4'b0111;
      cathodes <= segs3;
    end
    else begin
      anodes <= 4'b0111;
      cathodes <= 8'b11111111;
    end
  end

endmodule
