// Verilog Test Fixture Template

`timescale 1 ns / 1 ps

module tb_main;

  reg mclk;
  reg ctrl_write;
  reg ctrl_dstb;
  reg ctrl_rst;
  reg ctrl_astb;
  wire [7:0] data_bus;
  reg [7:0] data_out;
  reg output_en;

  reg [3:0] btn;                                                                                  
  reg [7:0] sw;                                                                                   
  wire [7:0] leds;                                                                                
  wire [0:7] segs;                                                                                
  wire [3:0] an;                                                                                  
  wire [3:0] ac; 

  assign data_bus = output_en ? data_out : 8'bz;

  main main0(mclk, btn, sw, leds, segs, an, ac,
             ctrl_write, ctrl_dstb, ctrl_rst, ctrl_astb, sta_wait, data_bus);


  initial begin
    ctrl_write = 1'b1;
    ctrl_dstb = 1'b1;
    ctrl_astb = 1'b1;
    ctrl_rst = 1'b0;
	 output_en = 1'b0;
	 data_out = 8'h0;
    btn = 4'b0;
    sw = 8'b0;
    #20;

    // write address

    ctrl_rst = 1'b1;
    data_out = 8'hAA; // may want to move later

    #10;

    ctrl_write = 1'b0;
    output_en = 1'b1;

    #10;

    ctrl_astb = 1'b0;

    #10;

    ctrl_astb = 1'b1;
    ctrl_write = 1'b1;

    #20;

    // write data

    data_out = 8'h55;
    ctrl_write = 1'b0;

    #10 ctrl_dstb = 1'b0;

    #10 ctrl_dstb = 1'b1;
    ctrl_write = 1'b1;
    

    #20;

    // read address back

    output_en = 1'b0;

    #10 ctrl_astb = 1'b0;

    #10 ctrl_astb = 1'b1;

    #20;

    // read data back

    ctrl_dstb = 1'b0;

    #10 ctrl_dstb = 1'b1;

    #20;
    
    $stop;

  end

  always begin
    mclk = 0'b0;
	 #1 mclk = 0'b1;
	 #1;
  end

endmodule
